local frac = FRACUNIT
local nfrac = 3000 // this probably isnt exact at all but it works

// momentum things
local maxSpeed = 80*frac // need new max speed, domikoto showcase video showed me that you can gain way to much speed
local minSpeed = 20*frac // cuz we dont like being SLOW!
local momGain = frac-frac/11 // momentum gain
local baseFriction = frac // friction

addHook("PlayerSpawn", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) return end
		
		X_ResetPlayerVariables(p)
	end
end)

// RECODING TIME!!!!!!!!!!!!!!!!!!!!!!!
addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) return end
		
		X_SetupPlayerVariables(p)
		
		if p.speed > minSpeed
			p.mo.friction = baseFriction
		else
			p.mo.friction = momGain
		end
		
		if p.speed > maxSpeed
			p.speed = maxSpeed
		end
		
		if ((p.pflags & PF_THOKKED)
		and (p.pflags & PF_JUMPED)
		and not (p.charflags & SF_NOJUMPSPIN))
		or p.thokking
			X_SpawnThokTrail(p)
		end
		
		if not (p.cmd.buttons & BT_CUSTOM1) then
			p.c1ready = true
			p.c1 = false
		elseif p.c1ready then
			p.c1 = true
			p.c1ready = false
		else
			p.c1 = false
		end
		
		if not (p.cmd.buttons & BT_CUSTOM2) then
			p.c2ready = true
			p.c2 = false
		elseif p.c2ready then
			p.c2 = true
			p.c2ready = false
		else
			p.c2 = false
		end
		
		if not (p.cmd.buttons & BT_CUSTOM3) then
			p.c3ready = true
			p.c3 = false
		elseif p.c3ready then
			p.c3 = true
			p.c3ready = false
		else
			p.c3 = false
		end
		
		// reroll and unroll
		if not (p.charflags & SF_NOJUMPSPIN)
		and not p.nightsstage
		and not p.powers[pw_carry]
		and p.climbing == 0
			if not P_IsObjectOnGround(p.mo)
			and not P_PlayerInPain(p)
			and not (p.pflags & PF_JUMPED)
			and not (p.pflags & PF_THOKKED)
			and not (p.pflags & PF_SPINNING)
			and p.playerstate ~= PST_DEAD
			and p.c1
				p.pflags = $1|PF_JUMPED|PF_THOKKED
				p.mo.state = S_PLAY_ROLL
				S_StartSound(nil, sfx_rerol, p)
			end
			
			if P_IsObjectOnGround(p.mo)
			and (p.pflags & PF_SPINNING)
			and p.mo.state == S_PLAY_ROLL
			and p.c1
				p.pflags = $ & ~PF_SPINNING
				p.mo.state = S_PLAY_STND
				S_StartSound(nil, sfx_rerol, p)
			end
		end
		
		// checks if youre in nights stage
		if p.powers[pw_carry] == CR_NIGHTSMODE
		or p.powers[pw_carry] == CR_NIGHTSFALL
			p.nightsstage = true
		else
			p.nightsstage = false
		end
		
		// run on water when going fast
		if not (skins[p.mo.skin].flags & SF_RUNONWATER)
			if p.speed > 50*frac
				p.charflags = $|SF_RUNONWATER
			else
				p.charflags = $ & ~SF_RUNONWATER
			end
		end
		
		if p.pflags & PF_SPINNING // spin control
		and not (p.pflags & PF_STARTDASH) 
		and P_IsObjectOnGround(p.mo)
			p.thrustfactor = (skins[p.mo.skin].thrustfactor)*10
		elseif not P_IsObjectOnGround(p.mo) // air control
			p.thrustfactor = (skins[p.mo.skin].thrustfactor)*2
		else
			p.thrustfactor = skins[p.mo.skin].thrustfactor
		end
		
		// kinda funny death effect
		if p.deathEffect
			if p.playerstate == PST_LIVE
				p.deathspin = FixedAngle((p.speed)/3)
			end
			
			if p.mo.state == S_PLAY_DEAD
			and not p.justDied
				P_InstaThrust(p.mo, p.mo.angle, p.speed/2)
				p.justDied = true
			end
			
			if p.playerstate == PST_DEAD
				p.mo.rollangle = $ + p.deathspin
				p.pflags = $1|PF_NOCLIP
			end
			
			if p.speed > 50*frac
			and p.mo.state == S_PLAY_DEAD
				P_FlashPal(p, PAL_WHITE, 5)
				S_StartSound(p.mo, sfx_bkpoof)
				P_StartQuake(50*frac, 2)
				p.mo.color = SKINCOLOR_JET
				p.mo.colorized = true
				p.mo.state = S_PLAY_DRWN
			end
		end
		
		if p.mo.rollangle ~= 0
		and p.playerstate == PST_REBORN // on reborn cuz it might break some scripts that change your rollangle
			p.mo.rollangle = 0
			if p.deathEffect
				p.mo.color = p.skincolor
				p.mo.colorized = false
				p.pflags = $ & ~PF_NOCLIP
				p.justDied = false
			end
		end
		
		// NIGHTS stuff
		// this wasnt really hard to do it was just a matter of find out how the fuck p.speed works for NIGHTS
		if p.powers[pw_carry] == CR_NIGHTSMODE
		and not (p.charflags & SF_NOJUMPSPIN)
		and p.mo.skin ~= "adventuresonic" // adventure sonic can already dash in NIGHTS stages
		and p.mo.skin ~= "SMS" // sms can as well and im pretty sure he has other stuff too
			if (p.cmd.buttons & BT_CUSTOM1)
				p.chargingdash = true
			else
				p.chargingdash = false
			end
			
			if p.chargingdash
				X_SpawnThokTrail(p)
				p.fakedashtime = $ + 1
				p.dashtime = $ + 1
				p.spinstate = $ + 1
				p.mo.state = S_PLAY_ROLL
				
				if p.speed > 5000
					p.speed = $ - 300
				end
			end
			
			if (p.fakedashtime % 4 == 1) // sound
				S_StopSoundByID(p.mo, sfx_spndsh)
				S_StartSound(p.mo, sfx_spndsh)
			end
			
			if p.spinstate > 6
				p.spinstate = 1
			end
			
			if p.dashtime > 50 // cap
				p.dashtime = 50
			end
			
			if not p.chargingdash and p.dashtime // if you let go
				S_StartSound(p.mo, sfx_zoom)
				p.speed = $ + (p.dashtime/10)*nfrac + nfrac
				p.chargingdash = false
				p.fakedashtime = 0
				p.dashtime = 0
				p.spinstate = 0
			end
			
			if p.speed > p.nightsspeedcap // speed cap cuz speed goes bonkers if its over 30k (30000)
				p.speed = p.nightsspeedcap
			end
			
			local state = p.spinstate
			
			if state == 1
				p.mo.frame = A
			elseif state == 2
				p.mo.frame = B
			elseif state == 3
				p.mo.frame = C
			elseif state == 4
				p.mo.frame = D
			elseif state == 5
				p.mo.frame = E
			elseif state == 6
				p.mo.frame = F
			end
		end
		
		// boost stuff
		if p.boostMechanic
			if p.speed > 35*frac or (p.pflags & PF_STARTDASH) or p.peelStart
				if (leveltime % 2 == 1)
					p.boostTime = $ + 1
				end
			end
			
			if p.boostLevel == 5
				if P_IsObjectOnGround(p.mo)
				and p.speed < 15*frac
				and not (p.pflags & PF_STARTDASH) 
				and not p.peelStart
					p.boostLevel = 0
					p.boostTime = 0
				end
			else
				if (P_IsObjectOnGround(p.mo)
				and p.speed < 35*frac
				and not (p.pflags & PF_STARTDASH) 
				and not p.peelStart)
				or p.powers[pw_carry]
					p.boostLevel = 0
					p.boostTime = 0
				end
			end
			
			if p.boostLevel > 0
				X_SpawnGhostTrailAdd(p, frac/4, true)
			end
			
			if p.boostTime > p.boostCap
				p.boostTime = p.boostCap
			end
			
			if (leveltime % 2 == 1)
				if p.boostTime == 30
					p.boostsound = 1
					p.boostLevel = 1
				end
				
				if p.boostTime == 60
					p.boostLevel = 2
				end
				
				if p.boostTime == 90
					p.boostsound = 2
					p.boostLevel = 3
				end
				
				if p.boostTime == 120
					p.boostLevel = 4
				end
				
				if p.boostTime == 150
					p.boostsound = 3
					p.boostLevel = 5
				end
			end
			
			if not p.boostsoundplayed
				if p.boostsound == 1
					S_StartSound(p.mo, sfx_bost)
					p.boostsoundplayed = true
					p.boostsound = 0
				elseif p.boostsound == 2
					S_StartSound(p.mo, sfx_bost2)
					p.boostsoundplayed = true
					p.boostsound = 0
				elseif p.boostsound == 3
					S_StartSound(p.mo, sfx_bost3)
					S_StartSound(p.mo, sfx_peel)
					X_SpawnRingEffect(p)
					p.boostsoundplayed = true
					p.boostsound = 0
				end
			end
			
			if p.boostsoundplayed
				p.boostsoundplayed = false
				p.boostTime = $ + 1
			end
			
			if p.boostLevel == 0
				p.normalspeed = skins[p.mo.skin].normalspeed
			end
			
			if p.boostLevel > 0 and p.boostLevel < 3
				p.normalspeed = skins[p.mo.skin].normalspeed + 5*frac
			end
			
			if p.boostLevel > 2 and p.boostLevel < 5
				p.normalspeed = skins[p.mo.skin].normalspeed + 10*frac
			end
			
			if p.boostLevel == 5
				p.normalspeed = skins[p.mo.skin].normalspeed * 2
				p.powers[pw_invulnerability] = 1
				
				if not (p.dashmode > 3*TICRATE
				and (p.charflags & SF_MACHINE))
					p.powers[pw_strong] = $1|STR_SPIKE
				end
			end
			
			if p.boostLevel < 5
			and (p.powers[pw_strong] & STR_SPIKE)
				if not (p.dashmode > 3*TICRATE
				and (p.charflags & SF_MACHINE))
					p.powers[pw_strong] = $ & ~STR_SPIKE
				end
			end
			
			
			if not (skins[p.mo.skin].flags & SF_CANBUSTWALLS)
				if p.boostLevel >= 3
					p.powers[pw_strong] = $1|STR_WALL
				else
					p.powers[pw_strong] = $ & ~STR_WALL
				end
			end
			
			if not (p.pflags & PF_GLIDING)
				if p.boostLevel >= 3
					p.powers[pw_strong] = $1|STR_PUNCH
				else
					p.powers[pw_strong] = $ & ~STR_PUNCH
				end
			end
			
			if (P_PlayerInPain(p) or p.mo.state == S_PLAY_PAIN)
				p.lostBoost = true
			else
				p.lostBoost = false
			end
			
			if p.lostBoost
			or p.playerstate == PST_DEAD
				p.boostLevel = 0
				p.boostTime = 0
			end
		end
	end
end)

addHook("TouchSpecial", function(mobj, pmo)
	if pmo.player.boostLevel >= 3 and (mobj.flags & MF_ENEMY)
		//P_KillMobj(mobj, pmo, pmo)
		//pmo.player.powers[pw_invulnerability] = 1
	end
end)

